
{----------------------------------------------------------------------------------------------}
{                                                                                              }
{ Ce code est plus fait pour etre lu que pour etre execute. Il a ete cree dans le but de servir}
{ d'aide memoire plus tard. Il marche (sans plus), mais son but est uniquement demonstratif.   }
{                                                                                              }
{ Beaucoup de constantes deja declarees dans les headers Windows sont redeclarees ici, dans le }
{ seul but de faciliter la lecture de ce source.                                               }
{                                                                                              }
{ Vous pouvez librement utiliser, modifier ou diffuser ce code tant que vous restez dans une   }
{ logique de partage et de non-profit.                                                         }
{                                                                                              }
{ Pour toutes remarques --> phaz at dune2 point info                                           }
{                                                                                              }
{    ~ Phaz ~                                                                                  }
{                                                                                              }
{----------------------------------------------------------------------------------------------}





UNIT TokenInfos ;

INTERFACE
 Uses
   JwaWintype,
   JwaWinNT;

 Type
   PSID       = JwaWinNT.PSID ;

   TGroupInfo = Record      // Utilise par EnumTokenGroups pour transmettre facilement les
     Sid     : PSID   ;     // informations trouvees sur un groupe.
     SidType : DWord  ;
     Name    : String ;
     Domain  : String ;
     Enabled   : Boolean ;
     ByDefault : Boolean ;
     LogonId   : Boolean ;
     Mandatory : Boolean ;
     Owner     : Boolean ;
     Resource  : Boolean ;
     UseForDenyOnly  : Boolean ;
   End ;

   TPrivilegeInfos = Record    // Utilise par EnumTokenPrivilege pour transmettre facilement les
     Name      : String  ;     // informations recuperees sur un privilege.
     iLUID     : LUID    ;
     Enabled   : Boolean ;
     ByDefault : Boolean ;
     Used      : Boolean ;
     Removed   : Boolean ;     // Ne sert pas avec NT/XP/2K
   End ;



 // Ces 4 fonctions utilisent toutes la fonction "GetTokenInformations", mais avec une classe
 //  d'information differente :

 //  Exemple d'appel de la fonction "GetTokenInformation" avec la classe "TokenPrivileges" :
 //    Permet d'enumerer tous les privileges contenus dans le Token du process specifie
 //    (en renvoyant le privilege d'index n) 
 Function EnumTokenPrivileges (hProcess      : Handle         ;
                               n             : Cardinal       ;
                               VAR rPrivInfos: TPrivilegeInfos;
                               VAR caError   : Cardinal       )
                                             : Boolean        ;


 // Exemple d'appel de la fonction "GetTokenInformation" avec la classe "TokenGroups" :
 //    Permet d'enumerer tous les groupes contenus dans le Token du process specifie
 //    (en renvoyant le groupe d'index n)
 Function EnumTokenGroups (hProcess     : Handle    ;
                           n            : Cardinal  ;
                           VAR rGrpInfos: TGroupInfo;
                           VAR caError  : Cardinal  )
                                        : Boolean   ;


 // Exemple d'appel de la fonction "GetTokenInformation" avec la classe "TokenUser" :
 //    Renvoie le SID du compte utilisateur contenu dans le Token du process specifie
 //    (cad le SID de l'utilisateur a qui est associe le Token)
 Function GetTokenUser (hProcess     : Handle  ;
                        VAR lpUserSid: PSID    ;
                        VAR caError  : Cardinal)
                                     : Boolean ;


 // Exemple d'appel de la fonction "GetTokenInformation" avec la classe "TokenOwner" :
 //    Renvoie le SID du compte (ou du groupe) proprietaire par defaut de tous les objets
 //    crees avec le Token du process specifie
 Function GetTokenOwner (hProcess      : Handle  ;
                         VAR lpOwnerSid: PSID    ;
                         VAR caError   : Cardinal)
                                       : Boolean ;

IMPLEMENTATION
 Uses
   JwaWinBase, JwaWinError, LookupAccount, LookupLuid ;

 Type
   // Le type PPrivilegesArray, utilise par EnumTokenPrivileges, permet d'acceder aux elements
   // d'indice > 0 dans une structure TOKEN_PRIVILEGES.
   TPrivilegesArray = array [0..1024] of TLuidAndAttributes;
   PPrivilegesArray = ^TPrivilegesArray;

   // Le type PTSIDArray, utilise par EnumTokenGroups, permet d'acceder aux elements > 0 dans
   // une structure TOKEN_GROUPS.
   TSIDArray  = Array [0..128]Of SID_AND_ATTRIBUTES   ;
   PTSIDArray = ^TSIDArray ;


{
================================================================================================
================================================================================================
::::::::::::::::::::::::::::::::::     GetTokenInformation     :::::::::::::::::::::::::::::::::
================================================================================================
================================================================================================


GetTokenInformation renvoie des informations concernant un Token. L'appelant doit specifier
quel type d'informations il veut recuperer parmi les differentes classes possibles.

 Cette fonction est utilisable sur les systemes suivants :
  Clients : [Windows XP], [Windows 2000 Professional], [Windows NT Workstation]
  Serveur : [Windows Server 2003], [Windows 2000 Server], [Windows NT Server]

------------------------------------------------------------------------------------------------
 Header          : Declared in Winbase.h; include Windows.h.
 Library         : Use Advapi32.lib.
 Unitee delphi   : JwaWinBase.pas
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


BOOL GetTokenInformation (                        // [out] 0 si erreur
  HANDLE                  TokenHandle,            // [in]  Designe le Token.
  TOKEN_INFORMATION_CLASS TokenInformationClass,  // [in]  Designe le type d'infos demandees
  LPVOID                  TokenInformation,       // [out] Pointe vers un buffer contenant
                                                  //       l'info recherchee  .
  DWORD                   TokenInformationLength, // [in]  Taille du buffer.
  PDWORD                  ReturnLength            // [out] Renvoie la taille necessaire, lorsque
                                                  //       la taille du buffer est insuffisante.
);

Rem : GetTokenInformation ne declenche pas d'exception ERROR_SUCCESS en cas de reussite.

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


 Voici une traduction (approximative) de la liste exhaustive des types d'informations possibles

 (Source : MSDN)

  ----------------------------------------------------------------------------------------------
 |  TokenDefaultDacl         Le buffer recoit une structure TOKEN_DEFAULT_DACL, contenant la
 |                             DACL par defaut des nouveaux objets crees.
  ----------------------------------------------------------------------------------------------
 |  TokenGroups              Le buffer recoit une structure TOKEN_GROUPS, contenant les SIDs des
 |                             groupes associes avec le Token.
  ----------------------------------------------------------------------------------------------
 |  TokenGroupsAndPrivileges Le buffer recoit une structure TOKEN_GROUPS_AND_PRIVILEGES, 
 |                             contenant le SID de l'utilisateur, les SIDs des groupes dont il
 |                             fait partie, les SIDs de restrictions et le Luid du Token.
  ----------------------------------------------------------------------------------------------
 |  TokenImpersonationLevel  Le buffer recoit une structure SECURITY_IMPERSONATION_LEVEL, 
 |                             indiquant le niveau de personnification du Token. 
  ----------------------------------------------------------------------------------------------
 |  TokenOrigin              Le buffer recoit une structure TOKEN_ORIGIN, contenant le LUID de  
 |                             la session qui a cree ce Token. (plus de details dans la MSDN)
  ----------------------------------------------------------------------------------------------
 |  TokenOwner               Le buffer recoit une structure TOKEN_OWNER, qui contient le SID du
 |                             proprietaire par defaut de tous les nouveaux objets crees.
  ----------------------------------------------------------------------------------------------
 |  TokenPrimaryGroup        Le buffer recoit une structure TOKEN_PRIMARY_GROUP, contenant le 
 |                             groupe principal par defaut de tous les nouveaux objets crees. 
  ----------------------------------------------------------------------------------------------
 |  TokenPrivileges          Le buffer recoit une structure TOKEN_PRIVILEGES contenant les 
 |                             privileges du Token et leur etat.
  ----------------------------------------------------------------------------------------------
 |  TokenRestrictedSids      Le buffer recoit une structure TOKEN_GROUPS, contenant la liste des
 |                             SIDs de restriction. La presence de SIDs de restriction dans un
 |                             Token peut seulement restreindre l'acces a certains objets, mais
 |                             jamais l'autoriser.
  ----------------------------------------------------------------------------------------------
 |  TokenSandBoxInert        Le buffer recoit un DWord non nul si le flag SANDBOX_INERT est
 |                             active dans le Token. Je n'ai pas trouve a quoi servait ce flag,
 |                             si en savez plus que moi, ce serait sympa de me mailer.
  ----------------------------------------------------------------------------------------------
 |  TokenSessionId           Le buffer recoit un DWord qui contient l'identificateur de session 
 |                             du Token. Ce DWord est non nul si le Token a ete cree depuis une 
 |                             session terminal server, et nul dans le cas inverse.
  ----------------------------------------------------------------------------------------------
 |  TokenSource              Le buffer recoit une structure TOKEN_SOURCE, contenant l'origine du
 |                             Token. Il s'agit d'une chaine de caracteres specifiant si le
 |                             Token a ete cree par Session Manager, LAN Manager ou RPC Server.
  ----------------------------------------------------------------------------------------------
 |  TokenStatistics          Le buffer recoit une structure contenant differentes statistiques
 |                             sur le Token. (voir la MSDN pour plus de details).
  ----------------------------------------------------------------------------------------------
 |  TokenType                Le buffer recoit une structure TOKEN_TYPE, qui indique si ce Token
 |                             est un Token principal ou s'il s'agit d'une personnification de
 |                             Token.
  ----------------------------------------------------------------------------------------------
 |  TokenUser                Le buffer recoit une structure TOKEN_USER, qui contient le SID de 
 |                             l'utilisateur a qui est attache le Token.
  ----------------------------------------------------------------------------------------------




Nous allons coder quatre fonctions, utilisant chacunes un type d'information different : 

1/ EnumTokenPrivileges (utilisation de la classe d'info 'TokenPrivileges').
2/ EnumTokenGroups (utilisation de la classe d'info 'TokenGroups').
3/ GetTokenUser (utilisation de la classe d'info 'TokenUser').
4/ GetTokenOwner (utilisation de la classe d'info 'TokenOwner').

------------------------------------------------------------------------------------------------


Remarques sur la manipulation des SIDs :
---------------------------------------

    Le SDK insiste lourdement sur le fait que l'on ne doit JAMAIS manipuler 'a la main' les
    structures de securite telles que les Security descriptors (SDs), les Security identifiers
    (SIDs) et les Access Control Lists (ACLs). Par 'a la main', je veux dire : en lisant ou en
    ecrivant directement en memoire, a l'adresse de la structure concernee.

    Pour manipuler ces structures, notamment pour les SIDs, le programmeur devra utiliser la
    fonction de l'API prevue a cet effet.

    Par exemple, il est incorrect de copier un SID ainsi :

     Sid2 := Sid1 ;

    Cela n'entraine aucune erreur de compilation, ni meme d'execution. Par contre, vous serez
    surpris de la valeur de Sid2 : ce n'est pas du tout celle de Sid1. Ce resultat inattendu
    risque fort de faire planter votre programme.

    Pour copier correctement un SID, il faut utiliser la fonction CopySid, declaree dans
    WinBase.h (ou JwWinBase.pas pour delphi).

    Il n'est par exemple pas non plus possible de comparer 2 SIDs comme ceci :

     If SID1 = SID2 Then ...

    Bien que ne declenchant aucune erreur d'execution, cette expression ne produira pas du
    tout le resultat attendu.
    La solution se trouve dans la fonction EqualSid, toujours dans WinBase.h

    Il existe de nombreuses autres fonctions permettant de manipuler les SIDs : En voici
    quelques unes :

    CopySid, IsValidSid, EqualSid, GetSidLength, GetLengthSid, AllocateAndInitializeSid,
    FreeSid,GetSidIdentifierAuthority, GetSidLengthRequired, GetSidSubAuthority,
    GetSidSubAuthorityCount, InitializeSid, etc ...

    Il serai trop long et ennuyeux de toutes les detailler ici, d'ailleurs la MSDN le fait tres
    bien (mais en anglais). On ne s'attardera donc que sur celles qui nous sont utiles dans ce
    code : CopySid, IsValidSid, et GetSidLength.

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

    CopySid copie un SID dans un buffer prealablement alloue par l'appelant.
    Apres utilisation, ce dernier doit liberer le SID avec HeapAlloc.

    BOOL CopySid (                  // Vrai si Succes
      DWORD nDestinationSidLength,  // Taille du SID Source (cf GetLengthSid)
      PSID  pDestinationSid,        // Pointe vers le Buffer de destination.
      PSID  pSourceSid              // Pointe vers le SID a copier.
    ) ;


    GetLengthSID renvoie la taille d'un SID en octets. Si le SID fournit n'est pas valide, le
    resultat de la fonction est imprevisible, il est donc preferable de s'assurer de la validite
    du SID avec IsValidSID avant d'appeler cette fonction.

    DWORD GetLengthSid (             // Renvoie la taille en octet du SID
      PSID pSid                      // Pointe vers le SID souhaite.
    ) ;


    La fonction IsValidSid renvoie vrai si le SID fournit est valide, et faux si il ne l'est pas
    IsValidSid ne genere pas d'erreur etendue : Ne pas appeler GetLastError

    BOOL IsValidSid (                // Vrai si SID valide
      PSID pSid                      // Designe le SID a tester
    ) ;


-------------------------------------</GetTokenInformation>-------------------------------------
}











(*
================================================================================================
:::::::::::::::::::::::::::::::::::::: EnumTokenPrivileges :::::::::::::::::::::::::::::::::::::
================================================================================================

  EnumTokenPrivileges renvoie une structure TPrivilegeInfos contenant le LUID, le nom chaine, et
  l'etat du privilege d'index n (c'est a dire du n ieme privilege du Token)

  Le type TPrivilegeInfos, declare dans l'interface de cette unite, est prevu pour passer
  facilement toutes ces informations a l'appelant dans une structure Record.


  L'etat d'un privilege est une combinaison entre les attributs suivants :
   - 0 (=Aucun attributs actives)
       Le privilege est desactive.
   - SE_PRIVILEGE_ENABLED
       Le privilege est active :)
   - SE_PRIVILEGE_ENABLED_BY_DEFAULT
       Le privilege est active par defaut :))
   - SE_PRIVILEGE_REMOVED : Si cet attribut est active avec AdjustTokenPrivilege, le privilege
       est definitivement retire de l'Access Token (jusqu'a la fin de la session).
       Attention : d'apres la MSDN, avec NT/2000/XP, AdjustTokenPrivilege ne peut pas retirer
       de privileges. Il ne reste guerre que Windows 2003 qui pourrait beneficier de cette
       fonction. (je n'ai pas teste). Cet attribut n'a donc que tres peu d'interet pour le
       moment.
   - SE_PRIVILEGE_USED_FOR_ACCESS
       Quand un ensemble de privileges est passe a CheckPrivileges (par exemple) , la fonction
       utilise cet attribut pour designer les privileges qui sont actives dans le Token.

  On rencontrera principalement SE_PRIVILEGE_ENABLED et SE_PRIVILEGE_ENABLED_BY_DEFAULT.

  En cas de reussite, la fonction renvoie vrai et en cas d'erreur, elle renvoie faux. La
  variable caError contient alors le numero de l'exception declenchee.
  Si n est superieur au nombre de privileges, caError renverra ERROR_NO_MORE_ITEMS (=259).

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  La fonction GetTokenInformation, utilisee avec la classe GetTokenPrivileges, renvoie une
  structure TOKEN_PRIVILEGES, qui est un tableau de LUID_AND_ATTRIBUTES.

  struct TOKEN_PRIVILEGES {
    DWORD PrivilegeCount;                          // Nombre total de privileges dans le tableau
    LUID_AND_ATTRIBUTES Privileges[ANYSIZE_ARRAY]; // ANYSIZE_ARRAY = 0
  }


  struct LUID_AND_ATTRIBUTES {
    LUID Luid;
    DWORD Attributes;
  }

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -



*)


Function EnumTokenPrivileges (

  hProcess       : Handle          ; // Designe le Process
  n              : Cardinal        ; // index (= 'n ieme' privilege)
  VAR rPrivInfos : TPrivilegeInfos ; // Contient les infos sur le privilege d'index n
                                     // rPrivInfos.Name = 'NUL' si echec.
  VAR caError    : Cardinal        ) // 0 si succes, numero de l'exception si echec
                 : Boolean         ; // Vrai si succes


 Var
   dwTokenPrivilegesSize : DWord ;
   lpTokenPrivileges : pTOKEN_PRIVILEGES ;
   lpPrivilegeArray  : PPrivilegesArray  ;
   hToken  : Handle  ;
   bSucces : Boolean ;

 Begin
   dwTokenPrivilegesSize := 0 ;
   caError := 0 ;
   hToken  := 0 ;
   lpTokenPrivileges := NIL ;
   lpPrivilegeArray  := NIL ;
   Result  := False ;
   bSucces := False ;

   With rPrivInfos Do
     Begin
      iLUID.LowPart  := 0 ;
      iLUID.HighPart := 0 ;
      Name      := 'NUL'  ;
      Enabled   := False  ;
      ByDefault := False  ;
      Used      := False  ;
     End ;

   SetLastError (0) ;

   // Ouverture du Token avec les droits TOKEN_QUERY
   bSucces := OpenProcessToken (GetCurrentProcess, TOKEN_QUERY, hToken) ;

   // Si Reussite, alors recuperation de la taille memoire necessaire pour pPrivilege
   If bSucces Then
     bSucces := GetTokenInformation ( hToken, TokenPrivileges, NIL, 0, dwTokenPrivilegesSize ) ;

   caError := GetLastError ;

   // Si tout ce passe bien, GetTokenInformation doit declencher l'exception 122
   If (caError = ERROR_INSUFFICIENT_BUFFER)        // ERROR_INSUFFICIENT_BUFFER = 122
     Then Begin
      bSucces := True ;
      caError := 0 ;
      SetLastError (0) ;
      // Allocation de dwTokenPrivilegesSize octets pour lpTokenPrivileges
      lpTokenPrivileges := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, dwTokenPrivilegesSize) ;
     End
     Else bSucces := False ;

   // Si l'allocation s'est bien passe, alors on effectue l'appel final a GetTokenInformation.
   If bSucces Then
     If lpTokenPrivileges <> NIL
       Then bSucces := GetTokenInformation (hToken, TokenPrivileges, lpTokenPrivileges,
                                            dwTokenPrivilegesSize, dwTokenPrivilegesSize)
       Else Begin
        caError := GetLastError ;
        bSucces := False       ;
       End ;

   // Si n est trop grand, EnumTokenPrivileges renverra l'erreur ERROR_NO_MORE_ITEMS.
   If n >= lpTokenPrivileges^.PrivilegeCount Then
     Begin
      bSucces := False ;
      caError := ERROR_NO_MORE_ITEMS ;  // ERROR_NO_MORE_ITEMS = 259
     End ;

   If bSucces Then  // A ce stade, tous les privileges sont transferes dans lpTokenPrivileges.
                    // Il ne reste plus qu'a copier le n ieme dans rPrivInfos.iLUID^
     Begin
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   Creation d'un pointeur pour acceder aux elements d'indice > 0 dans un TOKEN_PRIVILEGES.
   Si vous ne comprenez pas pourquoi on ne peut pas acceder a notre LUID avec l'expression
   'lpTokenPrivileges^.Privileges [n].Luid', reportez vous a l'explication a la fin de cette
   fonction.
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}

      lpPrivilegeArray := @lpTokenPrivileges^.privileges ;

      rPrivInfos.iLUID := lpPrivilegeArray^ [n].LUID ;

      // Recuperation du nom chaine du privilege.
      rPrivInfos.Name  := Luid2Privilege ('', rPrivInfos.iLUID, caError) ;
     End ;

   If bSucces Then
     If caError = 0 Then
       Begin
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 Si vous ne comprenez pas pourquoi '(lpPrivilegeArray^[n].Attributes AND SE_PRIVILEGE_ENABLED)',
 reportez vous a "Remarque sur le champ Attributes, les flags et les masques de bits", en 
 annexe, tout a la fin de ce fichier.
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}

        If (lpPrivilegeArray^[n].Attributes AND SE_PRIVILEGE_ENABLED ) <> 0
          Then rPrivInfos.Enabled := True  ;
        If (lpPrivilegeArray^[n].Attributes AND SE_PRIVILEGE_ENABLED_BY_DEFAULT ) <> 0
          Then rPrivInfos.ByDefault := True  ;
        If (lpPrivilegeArray^[n].Attributes AND SE_PRIVILEGE_USED_FOR_ACCESS ) <> 0
          Then rPrivInfos.Used := True  ;
        If (lpPrivilegeArray^[n].Attributes AND SE_PRIVILEGE_REMOVED ) <> 0
          Then rPrivInfos.Removed := True  ;
        // Etant donne que NT/XP/2K ne peuvent pas mofifier l'attribut SE_PRIVILEGE_REMOVED, il
        // n'est pas tres utile pour l'instant.
       End
       Else bSucces := False ;

   If caError <> 0 Then bSucces := False ;
   If bSucces AND (caError = 0) Then Result := True ;
   SetLastError (caError) ;

   // Liberation des pointeurs et handles
   If hToken <> 0 Then CloseHandle (hToken) ;
   If lpTokenPrivileges <> NIL Then HeapFree (GetProcessHeap, 0, lpTokenPrivileges) ;
 End ;


{---------------------------------</EnumTokenPrivileges>---------------------------------------}





{
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    <<  Acceder aux elements d'indice > 0 dans un TOKEN_PRIVILEGES (ou un TOKEN_GROUPS)  >>
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


  Dans la derniere fonction, GetTokenInformation nous renvoyait un pointeur lpTokenPrivileges 
  du type PTOKEN_PRIVILEGES. Ce pointeur, on l'a vu, designe une structure qui sert a stocker 
  des LUIDs et leur etat. Voici sa declaration en Delphi (legerement simplifiee) :


  Type
    TOKEN_PRIVILEGES = record                                  |   LUID_AND_ATTRIBUTES = record
      PrivilegeCount : DWORD                               ;   |     Luid       : LUID  ;
      Privileges     : array [0..0] of LUID_AND_ATTRIBUTES ;   |     Attributes : DWORD ;
    End;                                                       |   End;

    PTOKEN_PRIVILEGES : ^TOKEN_PRIVILEGES ;  
  
  Var
    lpTokenPrivileges : PTOKEN_PRIVILEGES ;



  Comme vous pouvez le remarquer, le champ "Privileges" de la structure TOKEN_PRIVILEGES est un
  tableau d'etendue [0..0].

  On voudrait bien ecrire "lpTokenPrivileges^.Privileges [n]" pour designer l'element souhaite,
  mais cela declenchera une erreur d'execution pour tout n > 0 (puisque l'etendue du tableau
  est [0..0]).

  Ce choix n'est pas une erreur, c'est une strategie deliberee qui permet de ne pas fixer de
  taille maximale pour ce tableau dans WinNT.h.

  Pour atteindre les elements d'indice > 0, nous avons besoin d'une structure du meme type que
  le champ "Privileges", mais avec une etendue plus grande. Par exemple :


  Type
    TPrivilegesArray = array [0..1024] of LUID_AND_ATTRIBUTES ;
    PPrivilegesArray = ^TPrivilegesArray;

  Var
    lpTokenPrivileges  : PTOKEN_PRIVILEGES ;   // Avec cette variable, on ne peut pas acceder a
                                               // lpTokenPrivileges^ [n]  quand n>0
    lpPrivilegeArray   : PPrivilegesArray  ;   // Tandis qu'avec celle la, on peut :)
 


  Avant d'acceder a "lpTokenPrivileges.Privileges", on va orienter notre deuxieme pointeur vers
  l'adresse de "lpTokenPrivileges.Privileges" comme ceci :

    lpPrivilegeArray   := @lpTokenPrivileges.Privileges ;

  De telle maniere que "lpPrivilegeArray^[n]" designe maintenant le meme element que
  "lpTokenPrivileges.Privileges", mais sans declencher d'erreur quand n est superieur a zero.

 
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    << / Acceder aux elements d'indice > 0 dans un TOKEN_PRIVILEGES (ou un TOKEN_GROUPS)  >>
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
}









(*
================================================================================================
:::::::::::::::::::::::::::::::::::::::::EnumTokenGroups::::::::::::::::::::::::::::::::::::::: 
:
================================================================================================




 EnumTokenGroups permet d'enumerer les groupes associes a un Token, c'est a dire les groupes
 auxquels l'utilisateur du Token appartient.

 La fonction attend un cardinal n en argument, et renvoie les informations sur le groupe 
 d'index n (c'est a dire le "n ieme" groupe).
 
 EnumTokenGroups renvoie :
  - le SID du groupe d'index n
  - le nom chaine associe au SID sur le systeme (si existant)
  - le nom de domaine auquel appartient ce SID.
  - le type du SID (Group, Alias, WhellknowGroup, etc.)
  - les attributs du groupe. (sous la forme de plusieurs champs booleens, chacun correspondant
    a un attribut. (voir plus bas pour plus de details sur les attributs)

 Le type TGroupInformation, declare dans l'interface de cette unite, est prevu pour passer
 toutes ces informations a l'appelant dans une structure Record.

 L'appelant devra liberer le SID avec HeapFree apres utilisation.

 La fonction renvoie vrai en cas de reussite et faux en cas d'echec. Dans ce cas, la variable
 caError renvoie le numero de l'exception qui vient de se declencher.

 Note :
       - Si n est superieur au nombre de privileges du Token, la fonction renverra l'erreur
          ERROR_NO_MORE_ITEMS (=259).
       - Si un SID invalide est rencontre, la fonction renverra ERROR_INVALID_SID (=1337)

 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

 L'appel de GetTokenInformation avec la classe TokenGroup provoque le renvoi d'une structure
 PTOKEN_GROUPS qui est un tableau de SID_AND_ATTRIBUTES.

 struct TOKEN_GROUPS {
   DWORD GroupCount;
   SID_AND_ATTRIBUTES Groups [ANYSIZE_ARRAY];
 }
 
 struct SID_AND_ATTRIBUTES {
   PSID  Sid;
   DWORD Attributes;
 }

 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

 Actuellement, il y a 7 attributs possibles :
  - SE_GROUP_ENABLED :
     Ce groupe est active :) Cela veut dire que l'utilisateur du Token est membre de ce groupe.
     Si cet attribut est active, lors de chaque verification d'acces, windows cherchera ce
     groupe dans la DACL de l'objet auquel l'utilisateur s'apprete a acceder. Le resultat peut
     aussi bien etre une autorisation qu'un refus d'acces.

     Si cet attribut est desactive, windows ignorera ce groupe lors des verifications d'acces.
     Cela signifie que l'utilisateur n'est pas considere comme membre de ce groupe, donc que
     ce groupe n'influe pas dans le controle d'acces de cet utilisateur, sauf si l'attribut
     SE_GROUP_USE_FOR_DENY_ONLY est active.

  - SE_GROUP_ENABLED_BY_DEFAULT :
     Ce groupe est active par defaut.

  - SE_GROUP_LOGON_ID :
     Ce SID est un "Logon SID" : il permet d'identifier la "logon session" qui a cree l'Access
     Token.

     La session (c'est l'expression que j'utiliserai pour "logon session") commence quand un
     utilisateur se connecte a un ordinateur windows en tapant son login et son mot de passe,
     et se termine quand l'utilisateur ferme la session.
     Lors de la connexion de l'utilisateur, le systeme cree un SID pour designer cette
     session. C'est le "Logon SID" et il est valide jusqu'a ce que l'utilisateur termine cette
     session.

     Note : les groupes ayant cet attribut ne possedent pas de nom. Tout appel a
            LookupAccountSID pour recuperer le nom du groupe declenchera l'exception
            ERROR_NONE_MAPED.

  - SE_GROUP_MANDATORY :
     Ce SID ne peut pas avoir son attribut Enabled mis a zero par un appel a AdjustTokenGroup
     (que nous n'etudions pas ici) : On ne peut pas desactiver ce groupe.

  - SE_GROUP_OWNER :
     Mystere. Si quelqu'un peut m'expliquer ...

  - SE_GROUP_RESOURCE :  (XP / 2K seulemennt )
     Ce SID designe un groupe ayant une etendue de domaine local.

  - SE_GROUP_USE_FOR_DENY_ONLY : (XP / 2K seulement )
     Le groupe est active uniquement pour les restrictions d'acces.
     Quand le systeme effectuera une verification de droit d'acces, windows cherchera ce 
     groupe dans la DACL de l'objet auquel l'utilisateur s'apprete a acceder, mais il ne
     tiendra compte du resultat que lorsque c'est un refus d'acces, et jamais si il s'agit
     d'une autorisation.
     Lorsque cet attribut a ete active pour un groupe, SE_GROUP_ENABLED est automatiquement
     desactive et ne peut plus etre reactive.


  Pour modifier ces attributs, il faut utiliser la fonction AdjustTokenGroups, qui n'est pas 
  implementee dans cette unite.

*)



Function EnumTokenGroups (hProcess      : Handle    ; // Handle vers le processus souhaite.
                          n             : Cardinal  ; // index
                          VAR rGrpInfos : TGroupInfo; // Strucrure TGroupInfo contenant les
                                                      // informations sur le groupe d'index n.
                          VAR caError   : Cardinal  ) // Code de retour : 0 si reussite.
                                        : Boolean   ; // 0 Si erreur


 Var
   hToken         : Handle        ;  // Denini dans JwaWinType.pas
   lpTokenGroups  : PTOKEN_GROUPS ;  // Defini dans JwaWinNT.pas
   lpSidArray     : PTSIDArray    ;  // Defini dans cette unitee
   dwGrpInfosSize : DWord         ;
   bSucces        : Boolean       ;

 Begin
   Result  := False ;
   bSucces := False ;
   lpSidArray    := NIL ;
   lpTokenGroups := NIL ;
   dwGrpInfosSize := 0  ;
   caError := 0 ;
   hToken  := 0 ;

   With rGrpInfos Do
     Begin
      Sid       := NIL   ;
      SidType   := 0     ;
      Name      := 'NUL' ;
      Domain    := 'NUL' ;
      Enabled   := False ;
      ByDefault := False ;
      LogonId   := False ;
      Mandatory := False ;
      Owner     := False ;
      Resource  := False ;
      UseForDenyOnly := False ;
     End ;

   SetLastError (0) ;

   // Ouverture du Token avec les droits TOKEN_QUERY
   bSucces := OpenProcessToken (hProcess, TOKEN_QUERY, hToken) ;

   // Recuperation de l'espace memoire necessaire pour lpTokenGroups grace a un appel de
   // GetTokenInformation avec un buffer de 0 octet
   If bSucces Then
     bSucces := GetTokenInformation ( hToken, TokenGroups, NIL, 0, dwGrpInfosSize ) ;

   caError := GetLastError ;

   // Il est normal de rencontrer l'exception 122 (= ERROR_INSUFFICIENT_BUFFER)
   If caError = ERROR_INSUFFICIENT_BUFFER Then
     Begin
      bSucces := True ;
      caError := 0 ;
      SetLastError (0) ;
      // Allocation de dwGrpInfosSize octets pour le buffer pointe par lpTokenGroups
      lpTokenGroups := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, dwGrpInfosSize) ;
     End
     Else bSucces := False ;

   // Si tout s'est deroule normalement, alors on effectue l'appel final a "GetTokenInformation"
   If bSucces Then
     If lpTokenGroups <> NIL
       Then bSucces := GetTokenInformation (hToken, TokenGroups, lpTokenGroups, dwGrpInfosSize,
                                            dwGrpInfosSize)
       Else Begin
        caError := GetLastError ;
        bSucces := False ;
       End ;

   // Si n est trop grand, on renvoie l'erreur ERROR_NO_MORE_ITEMS (= 259 )
   // NB : Les SIDs sont numerotes a partir de 0
   If bSucces AND (n >= lpTokenGroups^.GroupCount) Then
     Begin
      bSucces := False ;
      caError  := ERROR_NO_MORE_ITEMS ;
     End ;

   If bSucces Then
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  Creation d'un pointeur pour acceder aux elements d'indice > 0 dans un TOKEN_GROUPS. Il s'agit
  du meme probleme que pour les elements d'indice > 0 dans les TOKEN_PRIVILEGES. Reportez vous
  aux explications donnees a la fin de EnumTokenPrivileges pour plus de details.
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
     Begin
      lpSidArray := @lpTokenGroups^.Groups ;

      // Si le SID est valide, on alloue suffisamment de memoire pour le stocker dans le buffer
      // pointe par rGrpInfos.Sid
      If IsValidSid (lpSidArray^ [n].SID) Then
        rGrpInfos.Sid := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, // On utilise GetLengthSid
                         GetLengthSid (lpSidArray^ [n].Sid))          // plutot que SizeOf.
        Else Begin
         caError := ERROR_INVALID_SID ;
         bSucces := False ;
        End ;
     End ;

   // Si de la memoire a ete allouee pour rGrpInfos.Sid, alors on peut y copier le SID.
   If bSucces Then
     If rGrpInfos.Sid <> NIL  Then
       // On utilise CopySid plutot qu'une affectation 'manuelle' avec :=
       // (Voir les commentaires accompagnant "GetTokenInformation" a ce sujet)
       bSucces := CopySid (GetLengthSid (lpSidArray^[n].Sid), rGrpInfos.Sid, lpSidArray^[n].Sid) 
       Else Begin
        caError  := GetLastError ;
        bSucces := False ;
       End ;

   If bSucces Then
     If (IsValidSid (rGrpInfos.Sid)) Then
       Begin

{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 Si vous ne comprenez pas pourquoi '(lpSidArray^ [n].Attributes AND SE_GROUP_ENABLED) <> 0', 
 reportez vous a "Remarque sur le champ Attributes, les flags et les masques de bits", en
 annexe, tout a la fin de ce fichier.
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}

        If (lpSidArray^ [n].Attributes AND SE_GROUP_ENABLED) <> 0
          Then rGrpInfos.Enabled := True ;
        If (lpSidArray^ [n].Attributes AND SE_GROUP_ENABLED_BY_DEFAULT) <> 0
          Then rGrpInfos.ByDefault := True ;
        If (lpSidArray^ [n].Attributes AND SE_GROUP_LOGON_ID) <> 0
          Then rGrpInfos.LogonId := True ;
        If (lpSidArray^ [n].Attributes AND SE_GROUP_MANDATORY) <> 0
          Then rGrpInfos.Mandatory := True ;
        If (lpSidArray^ [n].Attributes AND SE_GROUP_OWNER) <> 0
          Then rGrpInfos.Owner := True ;
        If (lpSidArray^ [n].Attributes AND SE_GROUP_RESOURCE) <> 0
          Then rGrpInfos.Resource := True ; 
  
        If (lpSidArray^ [n].Attributes AND SE_GROUP_USE_FOR_DENY_ONLY) <> 0
          Then rGrpInfos.UseForDenyOnly := True ;

        // Recuperation du nom, du type et du nom de domaine correspondant au SID
        rGrpInfos.Name := GetAccountName ('', rGrpInfos.sid, rGrpInfos.Domain,
                                          rGrpInfos.SidType, caError) ;
        If (caError = ERROR_NONE_MAPPED) Then caError := 0 ;
        // Il arrive parfois qu'un SID valide n'ait pas de nom. Voici au moins deux exemples :

        // - Le SID est celui d'un groupe qui a ete supprime durant cette session : Le SID
        //   restera valide jusqu'a la fin de la session, mais tout appel a LookupAccountSID
        //   pour retouver son nom provoquera l'exception ERROR_NONE_MAPPED.
        // - Le SID est un "Logon SID" qui designe la session a qui a cree le Token.

        // ==> Il est preferable de simplement transmettre la chaine 'NUL' a la place du nom
        //     de l'acompte plutot que de transmettre un code d'erreur (via la variable caError)
        //     qui obligerai l'appelant a interrompre son enumeration pour traiter l'erreur.

       End
       Else Begin
        caError := ERROR_INVALID_SID ;
        bSucces := False ;
       End ;

   If caError <> 0 Then bSucces := False ;
   If bSucces AND (caError = 0) Then Result := True ;
   SetLastError (caError) ;

   // On libere proprement "hToken" et "lpTokenGroups".
   If hToken <> 0 Then CloseHandle (hToken) ;
   If lpTokenGroups <> NIL Then HeapFree (GetProcessHeap, 0, lpTokenGroups) ;
 End ;

{------------------------------------</EnumTokenGroups>----------------------------------------}







(*
================================================================================================
::::::::::::::::::::::::::::::::::::::::: GetTokenUser :::::::::::::::::::::::::::::::::::::::::
================================================================================================


 Cette fonction recupere le SID de l'utilisateur a qui appartient le Token.

 L'appelant devra liberer ce SID avec HeapFree apres usage.

 La fonction renvoie vrai en cas de reussite et faux en cas d'erreur. Dans ce cas, le numero de
 l'exception est transmis par la variable caError.

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

 L'appel de GetTokenInformation avec la classe TokenUser provoque le renvoi d'une structure
 SID_AND_ATTRIBUTES, dont voici la declaration :

  struct SID_AND_ATTRIBUTES {
    PSID  Sid;
    DWORD Attributes;
  }

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*)



Function GetTokenUser (hProcess      : Handle  ;
                       VAR lpUserSid : PSID    ;
                       VAR caError   : Cardinal)
                                     : Boolean ;

 Var
   lpUserSidAndAttr : PSID_AND_ATTRIBUTES ;
   dwUserSidSize    : DWord   ;
   hToken           : Handle  ;
   bSucces          : Boolean ;

 Begin
   bSucces := False ;
   Result  := False ;
   caError := 0 ;
   hToken  := 0 ;
   dwUserSidSize := 0 ;
   lpUserSidAndAttr := NIL ;
   lpUserSid        := NIL ;

   SetLastError (0) ;

   // Ouverture du Token avec les droits TOKEN_QUERY
   bSucces := OpenProcessToken (hProcess, TOKEN_QUERY, hToken) ;

   // Recuperation de l'espace memoire necessaire pour lpUserSidAndAttr
   If bSucces Then
     bSucces := GetTokenInformation ( hToken, TokenUser, NIL, 0, dwUserSidSize ) ;

   caError := GetLastError ;

   // A ce stade, il est normal d'avoir cette erreur.
   If caError = ERROR_INSUFFICIENT_BUFFER Then
     Begin
      bSucces := True ;
      caError := 0 ;
      SetLastError (0) ;
      // Allocation de suffisamment de memoire pour lpUserSidAndAttr
      lpUserSidAndAttr := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, dwUserSidSize) ;
     End
     Else bSucces := False ;

   If bSucces Then
     If lpUserSidAndAttr <> NIL
       // Appel final a GetTokenInformation --> recuperation de lpUserSidAndAttr
       Then bSucces := GetTokenInformation (hToken, TokenUser, lpUserSidAndAttr, dwUserSidSize,
                                            dwUserSidSize)
       Else Begin
        caError := GetLastError ;
        bSucces := False ;
       End ;

   // Il faut maintenant creer un buffer suffisamment grand pour transmettre
   // lpUserSidAndAttr^.Sid a l'appelant.
   If bSucces Then
     // Avant d'appeler GetLengthSid, il faut verifier que le SID est valide
     If (IsValidSid (lpUserSidAndAttr.Sid))
       // Allocation de suffisamment de memoire pour lpUserSid
       Then lpUserSid  := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY,
                                     GetLengthSid (lpUserSidAndAttr^.SID))
       Else Begin
        caError := ERROR_INVALID_SID ;
        bSucces := False ;
       End ;

   If bSucces Then
     If lpUserSid <> NIL
       // Si allocation reussit, alors on peut copier lpUserSidAndAttr^.SID dans lpUserSid
       Then CopySid (GetLengthSid (lpUserSidAndAttr^.SID), lpUserSid, lpUserSidAndAttr^.SID)
       Else Begin
        caError := GetLastError ;
        bSucces := False ;
       End ;

   If caError <> 0 Then bSucces := False ;
   If bSucces AND (IsValidSid (lpUserSid)) Then Result   := True ;
   SetLastError (caError) ;

   If hToken <> 0 Then CloseHandle (hToken) ;
   If lpUserSidAndAttr <> NIL Then HeapFree (GetProcessHeap, 0, lpUserSidAndAttr) ;
 End ;

{--------------------------------------</GetTokenUser>-----------------------------------------}









(*
================================================================================================
:::::::::::::::::::::::::::::::::::::::: GetTokenOwner :::::::::::::::::::::::::::::::::::::::::
================================================================================================


 Renvoie le SID du proprietaire par defaut de touts les objets crees avec le Token du process
 specifie.

 L'appelant doit liberer le SID avec HeapFree quand il a fini de l'utiliser.

 La fonction revoie vrai en cas de reussite et faux en cas d'erreur. Dans ce cas, le numero de
 l'exception est transmis par la variable caError.


- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 Lors de l'appel de GetTokenInformation avec la classe TokenOwner, on recupere une structure
 SID_AND_ATTRIBUTES dont voici la declaration :

  struct SID_AND_ATTRIBUTES {
    PSID  Sid;
    DWORD Attributes;
  }

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*)



Function GetTokenOwner (hProcess       : Handle  ;
                        VAR lpOwnerSid : PSID    ;
                        VAR caError    : Cardinal)
                                       : Boolean ;

 Var
   lpOwnerSidAndAttr : PSID_AND_ATTRIBUTES ;
   dwOwnerSidSize : DWord ;
   hToken  : Handle  ;
   bSucces : Boolean ;

 Begin
   bSucces := False ;
   Result  := False ;
   caError := 0 ;
   hToken  := 0 ;
   dwOwnerSidSize := 0 ;
   lpOwnerSidAndAttr := NIL ;
   lpOwnerSid        := NIL ;

   SetLastError (0) ;

   // Ouverture du Token avec les droits TOKEN_QUERY
   bSucces := OpenProcessToken (hProcess, TOKEN_QUERY, hToken) ;

   // Recuperation de l'espace memoire necessaire pour lpOwnerSidAndAttr
   If bSucces Then
     bSucces := GetTokenInformation ( hToken, TokenOwner, NIL, 0, dwOwnerSidSize ) ;

   caError := GetLastError ;

   // A ce stade, il est normal d'avoir cette erreur.
   If caError = ERROR_INSUFFICIENT_BUFFER Then
     Begin
      bSucces := True ;
      caError := 0 ;
      SetLastError (0) ;
      // Allocation de suffisamment de memoire pour lpOwnerSidAndAttr
      lpOwnerSidAndAttr := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, dwOwnerSidSize) ;
     End
     Else bSucces := False ;

   If bSucces Then
     If lpOwnerSidAndAttr <> NIL Then
       // Appel final a GetTokenInformation --> recuperation de lpOwnerSidAndAttr
       bSucces := GetTokenInformation (hToken, TokenOwner, lpOwnerSidAndAttr, dwOwnerSidSize,
                                       dwOwnerSidSize)
       Else Begin
        caError := GetLastError ;
        bSucces := False ;
       End ;

   // Il faut maintenant allouer un buffer suffisamment grand pour transmettre
   // lpOwnerSidAndAttr^.Sid a l'appelant.
   If bSucces Then
     // Avant d'appeler GetLengthSid, il faut verifier que le SID est valide
     If (IsValidSid (lpOwnerSidAndAttr^.Sid)) Then
       // Allocation de suffisamment de memoire pour lpOwnerSid
       lpOwnerSid  := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY,
                                 GetLengthSid (lpOwnerSidAndAttr^.Sid))
       Else Begin
        caError := ERROR_INVALID_SID ;
        bSucces := False ;
       End ;

   If bSucces Then
     If lpOwnerSid <> NIL
       // Si l'allocation reussit, alors on peut copier lpOwnerSidAndAttr^.SID dans lpOwnerSid
       Then CopySid (GetLengthSid (lpOwnerSidAndAttr^.Sid), lpOwnerSid, lpOwnerSidAndAttr^.Sid)
       Else Begin
        caError := GetLastError ;
        bSucces := False ;
       End ;

   If caError <> 0 Then bSucces := False ;
   If bSucces AND (IsValidSid (lpOwnerSid)) Then Result := True ;
   SetLastError (caError) ;

   // Liberation !!
   If hToken <> 0 Then CloseHandle (hToken) ;
   If lpOwnerSidAndAttr <> NIL Then HeapFree (GetProcessHeap, 0, lpOwnerSidAndAttr) ;
 End ;


{--------------------------------------</GetTokenOwner>----------------------------------------}




END.



{

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
          <<   Remarque sur le champ Attributes, les flags et les masques de bits   >>
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


    La valeur du champ Attributes d'un LUID_AND_ATTRIBUTES ou d'un SID_AND_ATTRIBUTES (qui
    represente l'etat d'un privilege ou d'un groupe) est calculee d'une maniere particuliere,
    souvent rencontree en programmation systeme. Si vous connaissez deja les flags et les
    masques, vous pouvez passer ce (long) commentaire sans probleme.


    1/ Calculer la valeur du champ Attributes a partir de l'etat des differents attributs
    ------------------------------------------------------------------------------------

    Attributes est le resultat de la combinaison logique de plusieurs attributs, souvent appeles
    flags (drapeau en anglais). Par exemple pour un LUID_AND_ATTRIBUTES, le champ Attributes est
    le resultat de la combinaison des flags SE_PRIVILEGE_ENABLED_BY_DEFAULT,
    SE_PRIVILEGE_ENABLED, SE_PRIVILEGE_REMOVED et SE_PRIVILEGE_USED_FOR_ACCESS.

    A chaque flag correspond un Bit different du DWord Attributes, qui peut etre a 0 ou a 1,
    selon si l'attribut est active ou non (un peu comme un drapeau qui peut etre leve ou non)



     Bit N>:  | 31| 30~    (...)     ~ 5 | 4 | 3 | 2 | 1 | 0 |
              +---+---+---/ /--/ /---+---+---+---+---+---+---+
                                              /    |   |    \
              SE_PRIVILEGE_USED_FOR_ACCESS __/     |   |  SE_PRIVILEGE_ENABLED_BY_DEFAULT
                                                   |   |
                                                   |  SE_PRIVILEGE_ENABLED
                                                   |
                                            SE_PRIVILEGE_REMOVED

      Le principe est donc le suivant : Si le flag de SE_PRIVILEGE_REMOVED est active, (c'est a
      dire si le bit de SE_PRIVILEGE_REMOVED est a 1) cela veut dire que l'attribut
      SE_PRIVILEGE_REMOVED est active.


    Le resultat final (la combinaison de tous les attributs actives) est obtenu en effectuant un
    OU LOGIQUE (somme) entre les valeurs des differents attributs (= flags) qui sont actives.

    Voici les valeurs des quatre attributs qui nous interessent : 

    SE_PRIVILEGE_ENABLED_BY_DEFAULT  =  0x00000001  =  1  en decimal
    SE_PRIVILEGE_ENABLED             =  0x00000010  =  2  en decimal
    SE_PRIVILEGE_REMOVED             =  0x00000100  =  4  en decimal
    SE_PRIVILEGE_USED_FOR_ACCESS     =  0x00001000  =  8  en decimal

    (le prefixe 0x signifie qu'il s'agit de nombres binaires)

    Par exemple, calculons la valeur du champ Attributes si SE_PRIVILEGE_USED_FOR_ACCESS,  
    SE_PRIVILEGE_ENABLED_BY_DEFAULT, et SE_PRIVILEGE_ENABLED sont actives :

       SE_PRIVILEGE_ENABLED_BY_DEFAULT            0x00000001         1   en decimal
                  SE_PRIVILEGE_ENABLED   =        0x00000010    =    2   en decimal
     +    SE_PRIVILEGE_USED_FOR_ACCESS        OR  0x00001000       + 8   en decimal
    -----------------------------------      ----------------     -----                     
                            Attributes   =        0x00001011    =   11   en decimal

    ==> Si on veut que le champ Attributes ait ces 3 attributs actives, il faut ecrire
        
        Attributes := SE_PRIVILEGE_ENABLED_BY_DEFAULT + SE_PRIVILEGE_ENABLED +   
                      SE_PRIVILEGE_USED_FOR_ACCESS ;

    Tout ca pour en arriver la, ca fait peur ! Mais ca va vous aider a comprendre la suite.



    2/ Deduire l'etat des attributs a partir du champ Attributes
    ------------------------------------------------------------

    On vient de voir comment le systeme obtient un DWord a partir d'une collection d'Attributs
    (de flags) actives ou non. Mais nous ne savons toujours pas comment on peut obtenir des 
    flags actives ou non, en partant d'un DWord.

    Le probleme est de connaitre l'etat de chaque bits separement.

    Pour connaitre l'etat du bit n, nous allons d'abord creer un DWord dans lequel seul le bit 
    n est active. Ce DWord sera notre masque. Puis nous effectuerons un ET logique entre notre 
    variable et ce masque. Seul le bit n de notre variable sera conserve, les autres bits seront
    mis a 0.
    Un masque est donc un mot binaire servant a specifier quels bits doivent etre conserves dans 

    un autre mot binaire.

    Par exemple, pour garder seulement le troisieme bit d'un octet (c'est plus facile a dessiner
    qu'un DWord ;), nous allons utiliser un masque dont seul le troisieme bit est active :
    00001000 (le bit 0, dit 'bit de poids faible' est le bit le plus a droite du mot). En
    faisant un AND entre notre octet et notre masque, tous les 0 du masque vont desactiver les
    bits correspondant dans notre octet.

    Imaginons que notre mot soit 10110010 (au hasard)

                         Bit 2
      Bit 7                |  Bit 1
       |                   |   |  Bit 0
       |                   |   |   |
     +---+---+---+---+---+---+---+---+
     | 1 | 0 | 1 | 1 | 0 | 0 | 1 | 0 |   <<----- Notre octet
     +---+---+---+---+---+---+---+---+
                       |
                     Bit 3 --> celui qui nous interesse

      On voit que le troisieme bit est desactive. Mais comment le tester dans un programme ?

      En faisant :

           10110010    <<-- notre octet
      AND  00001000    <<-- notre masque (seul le bit 3 est active)
      -------------
       =   00000000    -->> le resultat est nul, donc le troisieme bit de notre octet n'est
                            pas active.

     Si le bit 3 etait active, notre octet serait egal a 10111010. Donc

           10111010    <<-- notre octet avec le bit 3 active
      AND  00001000    <<-- notre masque (seul le troisieme bit est active)
      -------------
       =   00001000    -->> le resultat n'est pas nul, donc le troisieme bit de notre octet est
                            active


    J'espere que vous comprenez le principe ! Maintenant, appliquons ca aux attributs de
    privileges :

    Imaginons que nous voulions connaitre les attributs d'un privilege, et que nous
    obtenions la valeur suivante dans le champ Attributes : 00001001 (=9 en decimal)

    Il nous faut tester un par un chacun des bits de ce mot, pour decider si l'attribut
    correspondant au bit teste est active ou non.
    Nous n'avons pas besoin de creer les masques nous meme, puisque chaque constantes designant
    un attribut (SE_PRIVILEGE_ENABLED, SE_PRIVILEGE_ENABLED_BY_DEFAULT, etc) porte la valeur du
    masque permettant d'isoler le bit correspondant a cet attribut :
    
    Par exemple :

    Pour tester le Bit 0, qui correspond a l'attribut SE_PRIVILEGE_ENABLED_BY_DEFAULT on evalue
    (Variable_Attributes AND SE_PRIVILEGE_ENABLED_BY_DEFAULT)
    Etant donne que SE_PRIVILEGE_ENABLED_BY_DEFAULT = 0x00000001, cette operation ne conserve
    que le bit 0 :

            00001001  --> notre valeur a tester
       AND  00000001  --> SE_PRIVILEGE_ENABLED_BY_DEFAULT : masque tous les bits sauf le bit 0
      --------------
            00000001  --> Resultat non nul : le bit 0 etait a 1

            ==> l'attribut SE_PRIVILEGE_ENABLED_BY_DEFAULT est active


    Pour tester le Bit 1 (correspondant a SE_PRIVILEGE_ENABLED), on fait
    (Variable_Attributes AND SE_PRIVILEGE_ENABLED)
    Etant donne que SE_PRIVILEGE_ENABLED = 0x00000010, cette operation ne conserve
    que le bit 1


            00001001  -->  notre valeur a tester
       AND  00000010  -->  SE_PRIVILEGE_ENABLED : masque tous les bits sauf le bit 1
       ------------- 
            00000000  -->> Resultat nul : le bit 1 etait a 0

            ==> l'attribut SE_PRIVILEGE_ENABLED est desactive


    Pour tester le Bit 2, on fait :

            00001001 --> notre valeur a tester
       AND  00000100 --> SE_PRIVILEGE_ENABLED : masque tous les bits sauf le bit 2
       -------------
            00000000 --> Resultat nul : le bit 2 etait a 0

            ==> l'attribut SE_PRIVILEGE_ENABLED est desactive


    Et ainsi de suite pour tous les autres bits...

    Conclusion : en testant  (Valeur AND Attributes_Mask),
                 - on obtient 0 si l'attribut correspondant a Attributes_Mask est a 0
                 - on obtient un resultat non nul si l'attribut correspondant a Attributes_Mask
                   est a 1

    Donc pour tester les Attributs d'un privilege, on ecrit donc :

    If (privileges.attributes AND SE_PRIVILEGE_ENABLED_BY_DEFAULT) <> 0
      Then SE_PRIVILEGE_ENABLED_BY_DEFAULT est active
    If (privileges.attributes AND SE_PRIVILEGE_ENABLED) <> 0
      Then SE_PRIVILEGE_ENABLED est active
    If (privileges.attributes AND SE_PRIVILEGE_REMOVED) <> 0
      Then SE_PRIVILEGE_REMOVED est active
    If (privileges.attributes AND SE_PRIVILEGE_USED_FOR_ACCESS) <> 0
      Then SE_PRIVILEGE_USED_FOR_ACCESS est active     

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
          << / Remarque sur le champ Attributes, les flags et les masques de bits   >>
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
}


